local on = true
local off = false

CLS_SettingsDefaults = {
MSBT = on,  -- Output achievement to Mik's Scrolling Battle Text
Sound = on, -- Enable Sound Output
Enable = on, -- enable/disable the addon 
CustomMP3 = off,
CustomOGG = off
}

CLS_SettingsDefaultsPC = {
RanOnce = false --Per char ran more than once
}

CLS_Settings = {}
CLS_SettingsPC = {}
CLS_List = {}

local List

CLS = {}

CLS.Frame = CreateFrame("Frame")
CLS.Frame:RegisterEvent("ADDON_LOADED")
CLS.Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

-- Local text colors
local yel = "|cFFFFFF00"
local wht = "|cFFFFFFFF"
local blu = "|cFF00FFFF"
local red = "|cFFFF0000"
local grn = "|cFF00FF00"
local res = "|r"

local function addOptionMt(options, defaults)
	setmetatable(options, {__index = defaults})
	for i, v in pairs(options) do
		if type(v) == "table" and not getmetatable(v) then
			addOptionMt(v, defaults[i])
		end
	end
end

local SJprint = function(...)
	print( string.join(" ", ...))
end

CLS.StatColor = function(stat)
	if (stat == on) then
		return "|cFF00FF00[on]"
	elseif (stat == off) then
		return "|cFFFF0000[off]"
	end
	return stat
end


CLS.Frame:SetScript("OnEvent",function(self, event, ...)
	local arg = ...
	if event == "ADDON_LOADED" and arg == "CombatLogScanner" then
		SJprint(red, "Combat Log Scanner loaded", res)
		addOptionMt( CLS_Settings , CLS_SettingsDefaults )
		addOptionMt( CLS_SettingsPC , CLS_SettingsDefaultsPC )
		
		if not(CLS_SettingsPC.RanOnce) then
			SJprint(yel, "\nCombat Log Scanner", res)
			SJprint(yel, " Please set watched for Spell Names this char.", res)
			print("\n\n")
			CLS_SettingsPC.RanOnce = true
		end
		
		return self, event, ...
	end
	
	if not(CLS_Settings.Enable) then
		return
	end
	local timestamp, eventType, hidecaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, spellId, spellName = ...
	local R,G,B = 255, 255, 255
	local match = false
	
	if eventType ~= "SPELL_CAST_START" then
		return
	end

	if type(spellName) ~= "string" then
		return
	end
	
	if #CLS_List > 0 then
		for x = 1, #CLS_List do
			if string.find( string.lower( spellName ), string.lower(CLS_List[x]) )then
				match = true
			end
		end
	end
	
	if not(match) then
		return
	end
	
	local output = string.join(" ", eventType, " ", sourceName, " ", spellName )
	print(output)
	
	if CLS_Settings.MSBT and IsAddOnLoaded("MikScrollingBattleText") then
		if not(MikSBT.IsModDisabled()) then
			MikSBT.DisplayMessage( output , MikSBT.DISPLAYTYPE_NOTIFICATION, true, R, G, B)
		end
	end

	if CLS_Settings.Sound then
		if CLS_Settings.CustomMP3 then
			PlaySoundFile("Interface\\AddOns\\CombatLogScanner\\alert.mp3")
		elseif CLS_Settings.CustomOGG then
			PlaySoundFile("Interface\\AddOns\\CombatLogScanner\\alert.ogg")
		else
			PlaySound("READYCHECK")
		end
	end
end)


CLS.CmdLine = function( msg )
	local cmd, arg = string.split(" ", msg)
	local spell = arg
	cmd = string.lower(cmd)
	
	if cmd == "on" or cmd == "off" then
		CLS_Settings.Enable = (cmd == "on")
		SJprint( yel, "Combat Log Scanner: Addon is", CLS.StatColor( CLS_Settings.Enable ), res)
		return
	end

	if not(CLS_Settings.Enable) then
		SJprint( yel, "Combat Log Scanner: The addon is disabled type \"", blu, "/cls on", yel, "to enable", res)
		return
	end
	
	if cmd == "" then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Combat Log Scanner:", res)
		SJprint( yel, "  Addon is", CLS.StatColor( CLS_Settings.Enable ), res)
		SJprint( blu, "  MSBT", yel, "is", CLS.StatColor( CLS_Settings.MSBT ), res)
		SJprint( blu, "  Sound", yel, "is", CLS.StatColor( CLS_Settings.Sound ), res)
		SJprint( blu, "  CustomMP3", yel, "is", CLS.StatColor( CLS_Settings.CustomMP3 ), res)
		SJprint( blu, "  CustomOGG", yel, "is", CLS.StatColor( CLS_Settings.CustomOGG ), res)
		print(" ")
		SJprint( yel, #CLS_List, "watched spells are stored for this character.")
		return
	end
	
	if cmd == "msbt" then
		if arg == "on" or arg == "off" then
			CLS_Settings.MSBT = (arg == "on")
		end
		SJprint( yel, "Combat Log Scanner: MSBT is", CLS.StatColor( CLS_Settings.MSBT ), res)
		return
	end
	
	if cmd == "sound" then
		if arg == "on" or arg == "off" then
			CLS_Settings.Sound = (arg == "on")
		end
		SJprint( yel, "Combat Log Scanner: Sound is", CLS.StatColor( CLS_Settings.Sound ), res)
		return
	end
	
	if cmd == "add" then
		local set = false
		
		if spell == nil then
			SJprint( yel, " Combat Log Scanner: Spell Name entry error \n \"/cls add SPELLNAME\"", res)
			return
		end
	
		if #CLS_List > 0 then
			for x = 1, #CLS_List do
				if CLS_List[x] == spell then
					set = true
				end
			end
		end
	
		if not(set) then
			local index
			if #CLS_List == nil then
				index = 1
			else
				index = #CLS_List + 1
			end
			CLS_List[index] = spell
		end

		SJprint( yel, " Combat Log Scanner: Spell Name stored as:", spell  , res)
		table.sort(CLS_List)
		return
	end

	if cmd == "rem" then
		local rem = false
		local number = tonumber( spell )
		
		if spell == nil then
			SJprint( yel, " Combat Log Scanner: Spell Name entry error \n \"/cls rem SPELLNAME\"", res)
			return
		end
	
		if #CLS_List > 0 and number == nil then
			for x = 1, #CLS_List do
				if CLS_List[x] == spell then
					table.remove(CLS_List, x)
					rem = true
				end
			end
		end
		
		if number > 0 and number <= #CLS_List then
			spell = CLS_List[number]
			table.remove(CLS_List, number)
			rem = true
		end
		
		if not(rem) then
			SJprint( yel, " Combat Log Scanner: Error \n Unable to find Spell:", spell , " to remove from the spell list", res)
		else
			SJprint( yel, " Combat Log Scanner: SPELL:", spell , " removed from spell list", res)
		end
		return	
	end
	
	if cmd == "display" then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Combat Log Scanner", res)
		SJprint( yel, "  Spell Names List", res)
		SJprint( yel, "#  Spell:", res)
		if #CLS_List > 0 then
			for x = 1, #CLS_List do
				SJprint( yel, x, "  ", CLS_List[x], "\n", res)
			end
			SJprint( yel, #CLS_List, "Spell names stored for this server", res)
		else
			SJprint( yel, "ERROR: No spell names stored", res)
		end
		return
	end

	if cmd == "custommp3" then
		if arg == "on" or arg == "off" then
			CLS_Settings.CustomMP3 = (arg == "on")
		end
		SJprint( yel, "Combat Log Scanner: CustomMP3 is", CLS.StatColor( CLS_Settings.CustomMP3 ), res)
		return
	end

	if cmd == "customogg" then
		if arg == "on" or arg == "off" then
			CLS_Settings.CustomOGG = (arg == "on")
		end
		SJprint( yel, "Combat Log Scanner: CustomOGG is", CLS.StatColor( CLS_Settings.CustomOGG ), res)
		return
	end
	
	SJprint( yel, "________________________________________", res)
	SJprint( yel, "Combat Log Scanner:", res)
	SJprint( blu, "  /cls cmd", res)
	SJprint( red, cmd, yel, "is not a valid command", res)
	SJprint( yel, "  Commands are:", res)
	SJprint( blu, "     on", yel, "/", blu, "off", wht, "Turns scanner on and off", res)
	SJprint( blu, "     MSBT", yel, "Enable output to MikScrollingBattleText if installed [on / off]", res)
	SJprint( blu, "     Sound", yel, "Enable sound when a match is found [on / off]", res)
	SJprint( blu, "     CustomMP3", yel, "Enable custom alert.mp3 sound when a match is found [on / off]", res)
	SJprint( blu, "     CustomOGG", yel, "Enable custom alert.ogg sound when a match is found [on / off]", res)
	SJprint( blu, "     add", yel, "Adds a spell name \"/cls add SPELLNAME\"", res)
	SJprint( blu, "     rem", yel, "Removes a spell name \"/cls rem SPELLNAME\" or \"/cls rem NUMBER\" (number from DISPLAY)", res)
	SJprint( blu, "     display", yel, "Displays list of saved spell names", res)
	print(" ")
	SJprint( yel, "Combat Log Scanner:  Addon is", CLS.StatColor( CLS_Settings.Enable ), res)
	SJprint( yel, "and", #CLS_List, "spell names are stored for this character.", res)
	return
end


SLASH_CLS1 = "/cls"
SlashCmdList["CLS"] = function(msg)
	CLS.CmdLine(msg)
end
